/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2009 The Nimbus2 Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE NIMBUS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE NIMBUS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the Nimbus2 Project.
 */
package jp.ossc.nimbus.service.cache;

import java.util.*;

import jp.ossc.nimbus.core.ServiceBase;

/**
 * Least Recently Used あふれアルゴリズムサービス。<p>
 * 以下に、LRUであふれ対象となるキャッシュオブジェクトを決定するあふれアルゴリズムサービスのサービス定義例を示す。<br>
 * <pre>
 * &lt;?xml version="1.0" encoding="Shift_JIS"?&gt;
 * 
 * &lt;nimbus&gt;
 *     
 *     &lt;manager name="Sample"&gt;
 *         
 *         &lt;service name="LRUOverflowAlgorithm"
 *                  code="jp.ossc.nimbus.service.cache.LRUOverflowAlgorithmService"/&gt;
 *         
 *     &lt;/manager&gt;
 *     
 * &lt;/nimbus&gt;
 * </pre>
 *
 * @author M.Takata
 */
public class LRUOverflowAlgorithmService<E> extends ServiceBase
 implements OverflowAlgorithm<E>, CacheRemoveListener<E>, CacheAccessListener<E>,
            java.io.Serializable, LRUOverflowAlgorithmServiceMBean{
    
    private static final long serialVersionUID = 2274633140923055371L;
    
    private Map<CachedReference<E>, TimeCachedReference<E>> referenceMap;
    private List<TimeCachedReference<E>> referenceList;
    
    // LRUOverflowAlgorithmServiceMBeanのJavaDoc
    @Override
    public int size(){
        return referenceMap == null ? 0 : referenceMap.size();
    }
    
    /**
     * サービスの生成処理を行う。<p>
     * インスタンス変数の初期化を行う。
     *
     * @exception Exception サービスの生成処理に失敗した場合
     */
    @Override
    public void createService() throws Exception{
        referenceMap = Collections.synchronizedMap(new HashMap<CachedReference<E>, TimeCachedReference<E>>());
        referenceList = Collections.synchronizedList(new ArrayList<TimeCachedReference<E>>());
    }
    
    /**
     * サービスの破棄処理を行う。<p>
     * インスタンス変数の開放を行う。
     *
     * @exception Exception サービスの破棄処理に失敗した場合
     */
    @Override
    public void destroyService() throws Exception{
        reset();
        referenceMap = null;
        referenceList = null;
    }
    
    /**
     * キャッシュ参照を追加する。<p>
     * 引数で渡されたキャッシュ参照を保持する。同時に、{@link CachedReference#addCacheAccessListener(CacheAccessListener)}で、{@link CacheAccessListener}として自分自身を登録する。また、{@link CachedReference#addCacheRemoveListener(CacheRemoveListener)}で、{@link CacheRemoveListener}として自分自身を登録する。<br>
     *
     * @param ref キャッシュ参照
     */
    @Override
    public void add(CachedReference<E> ref){
        if(referenceMap == null || ref == null){
            return;
        }
        synchronized(referenceMap){
            if(!referenceMap.containsKey(ref)){
                TimeCachedReference<E> tmc = new TimeCachedReference<E>(ref);
                referenceMap.put(ref, tmc);
                referenceList.add(tmc);
                ref.addCacheAccessListener(this);
                ref.addCacheRemoveListener(this);
            }
        }
    }
    
    /**
     * キャッシュ参照を削除する。<p>
     * 引数で渡されたキャッシュ参照を内部で保持している場合は、破棄する。同時に、{@link CachedReference#removeCacheAccessListener(CacheAccessListener)}で、{@link CacheAccessListener}として自分自身を登録解除する。また、{@link CachedReference#removeCacheRemoveListener(CacheRemoveListener)}で、{@link CacheRemoveListener}として自分自身を登録解除する。<br>
     *
     * @param ref キャッシュ参照
     */
    @Override
    public void remove(CachedReference<E> ref){
        if(referenceMap == null || ref == null){
            return;
        }
        synchronized(referenceMap){
            if(referenceMap.containsKey(ref)){
                TimeCachedReference<E> tmc = referenceMap.remove(ref);
                referenceList.remove(tmc);
                ref.removeCacheAccessListener(this);
                ref.removeCacheRemoveListener(this);
            }
        }
    }
    
    /**
     * 参照されてない時間が最も長いキャッシュ参照をあふれさせる。<p>
     * {@link #add(CachedReference)}で渡されたキャッシュ参照の中から、参照されてない時間が最も長いキャッシュ参照を、あふれキャッシュ参照として返す。<br>
     *
     * @return 参照されてない時間が最も長いキャッシュ参照
     */
    @Override
    public CachedReference<E> overflow(){
        if(referenceMap == null){
            return null;
        }
        synchronized(referenceMap){
            if(referenceMap.size() != 0){
                Collections.sort(referenceList);
                TimeCachedReference<E> tmc = referenceList.remove(0);
                referenceMap.remove(tmc.getCachedReference());
                return tmc.getCachedReference();
            }
            return null;
        }
    }
    
    /**
     * 参照されてない時間が最も長いキャッシュ参照をあふれさせる。<p>
     * {@link #add(CachedReference)}で渡されたキャッシュ参照の中から、参照されてない時間が最も長いキャッシュ参照を、あふれキャッシュ参照として返す。<br>
     *
     * @param size あふれ数
     * @return 参照されてない時間が最も長いキャッシュ参照
     */
    @SuppressWarnings("unchecked")
    public CachedReference<E>[] overflow(int size){
        if(referenceMap == null || referenceMap.size() == 0){
            return null;
        }
        synchronized(referenceMap){
            if(referenceMap.size() != 0){
                final CachedReference<E>[] result = new CachedReference[Math.min(referenceMap.size(), size)];
                Collections.sort(referenceList);
                for(int i = 0; i < result.length; i++){
                    TimeCachedReference<E> tmc = referenceList.remove(0);
                    referenceMap.remove(tmc.getCachedReference());
                    result[i] = tmc.getCachedReference();
                }
                return result;
            }
            return null;
        }
    }
    
    /**
     * あふれアルゴリズムを実行するために保持している情報を初期化する。<p>
     * {@link #add(CachedReference)}で渡されたキャッシュ参照を全て破棄する。<br>
     */
    @Override
    public void reset(){
        synchronized(referenceMap){
            if(referenceMap != null){
                referenceMap.clear();
            }
            if(referenceList != null){
                referenceList.clear();
            }
        }
    }
    
    /**
     * キャッシュから削除されたキャッシュ参照の通知を受ける。<p>
     * {@link #remove(CachedReference)}を呼び出す。<br>
     *
     * @param ref キャッシュから削除されたキャッシュ参照
     */
    @Override
    public void removed(CachedReference<E> ref){
        remove(ref);
    }
    
    /**
     * 参照されたキャッシュ参照の通知を受ける。<p>
     * 内部で保持しているキャッシュ参照のリストに含まれる場合は、最後尾に移動させる。<br>
     *
     * @param ref 参照されたキャッシュ参照
     */
    @Override
    public void accessed(CachedReference<E> ref){
        if(referenceMap == null){
            return;
        }
        synchronized(referenceMap){
            if(referenceMap != null && referenceMap.containsKey(ref)){
                TimeCachedReference<E> tmcRef = referenceMap.get(ref);
                if(tmcRef != null){
                    tmcRef.access();
                }
            }
        }
    }
    
    private static class TimeCachedReference<E>
     implements java.io.Serializable, Comparable<TimeCachedReference<E>>{
        
        private static final long serialVersionUID = 1731034355455490827L;
        private CachedReference<E> reference;
        private long lastAccessTime;
        
        public TimeCachedReference(CachedReference<E> ref){
            reference = ref;
            lastAccessTime = System.currentTimeMillis();
        }
        public CachedReference<E> getCachedReference(){
            return reference;
        }
        
        public void access(){
            lastAccessTime = System.currentTimeMillis();
        }
        
        public long getLastAccessTime(){
            return lastAccessTime;
        }
        
        public int compareTo(TimeCachedReference<E> comp) {
            if(comp == null){
                return 1;
            }
            if(comp == this){
                return 0;
            }
            final long diff = lastAccessTime - comp.getLastAccessTime();
            if(diff == 0){
                return 0;
            }else if(diff > 0){
                return 1;
            }else{
                return -1;
            }
        }
     }
}
